<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 04/11/19
 * Time: 0.42
 */

namespace FiloBlu\Rma\Plugin\Model;
use FiloBlu\Rma\Plugin\Block\Form\Renderer\Select;
use FiloBlu\Rma\Helper\ChangeSizeAttributeHelper;


class HideChangeSizeResolution
{

    /**
     * @var ChangeSizeAttributeHelper
     */
    protected $changeSizeAttributeHelper;

    /**
     * @var Select
     */
    protected $select;

    /**
     * HideChangeSizeResolution constructor.
     * @param Select $select
     * @param ChangeSizeAttributeHelper $changeSizeAttributeHelper
     */
    public function __construct(Select $select,
                                ChangeSizeAttributeHelper $changeSizeAttributeHelper){
        $this->select = $select;
        $this->changeSizeAttributeHelper = $changeSizeAttributeHelper;
    }

    /**
     * Soltanto ADMIN 
     * L'opzione "change_size" dell'attributo "resolution" NON va mostrata nei seguenti casi:
     * 1. se la funzionalità Cambio Taglia è disabilitata in: 
     *    Stores -> Configuration -> FiloBlu -> RMA Configuration -> Allow User to choose Change Size Option
     * 2. se l'ordine di cui sto chiedendo il reso ha come metodo di pagamento "Change Size Pay": 
     *    non si può chiedere il cambio taglia per la seconda volta (solo area personale cliente - il CC sa quello che fa)
     * @param \Magento\Rma\Helper\Eav $subject
     * @param $result
     * @return array
     */
    public function afterGetAttributeOptionValues(\Magento\Rma\Helper\Eav $subject, $result){

        $allOptions = $result;
        $allowed = [];
        if(!$this->select->changeSizeIsEnabled()){
            foreach ($result as $key => $options){
                if(!in_array($options,$this->changeSizeAttributeHelper->getAllChangeSizeLabel())){
                    $allowed [$key]= $options;
                }
            }
            $result = $allowed;
        }
        return $result;
    }

}